<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>react-native-bluetooth-serial: React Native Bluetooth Serial</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">react-native-bluetooth-serial
   &#160;<span id="projectnumber">1.0.0</span>
   </div>
   <div id="projectbrief">Port of https://github.com/don/BluetoothSerial for react native</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">React Native Bluetooth Serial </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>React Native version of <a href="https://github.com/don/BluetoothSerial">BluetoothSerial</a> plugin. For both android and ios</p>
<h1><a class="anchor" id="autotoc_md1"></a>
Compatibility</h1>
<p>Officialy this library supports React Native &gt;= 0.25, it may run on older versions but no guarantees.</p>
<h1><a class="anchor" id="autotoc_md2"></a>
Installation</h1>
<ol type="1">
<li>Install package via npm: <code>npm i -S react-native-bluetooth-serial</code></li>
<li>Link libraries with: <code>rnpm link</code> or <code>react-native link</code> for React Native &gt;= 0.27</li>
<li>For android you also need to put following code to <code>AndroidManifest.xml</code> <div class="fragment"><div class="line">&lt;uses-permission android:name=&quot;android.permission.BLUETOOTH&quot; /&gt;</div>
<div class="line">&lt;uses-permission android:name=&quot;android.permission.BLUETOOTH_ADMIN&quot; /&gt;</div>
</div><!-- fragment --></li>
</ol>
<h1><a class="anchor" id="autotoc_md3"></a>
Manual installation</h1>
<h3><a class="anchor" id="autotoc_md4"></a>
iOS</h3>
<ol type="1">
<li><code>npm i -S react-native-bluetooth-serial</code></li>
<li>In XCode, in the project navigator, right click <code>Libraries</code> ➜ <code>Add Files to [your project's name]</code></li>
<li>Go to <code>node_modules</code> ➜ <code>react-native-bluetooth-serial</code> and add <code>RCTBluetoothSerial.xcodeproj</code></li>
<li>In XCode, in the project navigator, select your project. Add <code>libRCTBluetoothSerial.a</code> to your project's <code>Build Phases</code> ➜ <code>Link Binary With Libraries</code></li>
<li>Click <code>RCTBluetoothSerial.xcodeproj</code> in the project navigator and go the <code>Build Settings</code> tab. Make sure 'All' is toggled on (instead of 'Basic'). In the <code>Search Paths</code> section, look for <code>Header Search Paths</code> and make sure it contains both <code>/../../react-native/React</code> and <code>/../../../React</code> - mark both as <code>recursive</code>.</li>
</ol>
<ol type="1">
<li>Run your project (<code>Cmd+R</code>)</li>
</ol>
<h3><a class="anchor" id="autotoc_md5"></a>
Android</h3>
<ol type="1">
<li><code>npm i -S react-native-bluetooth-serial</code></li>
<li>Open up <code>android/app/src/main/java/[...]/MainActivity.java</code> or <code>MainApplication.java</code> for React Native &gt;= 0.29<ul>
<li>Add <code>import <a class="el" href="../../db/d7f/namespacecom_1_1rusel_1_1RCTBluetoothSerial.html">com.rusel.RCTBluetoothSerial</a>.*;</code> to the imports at the top of the file</li>
<li>Add <code>new RCTBluetoothSerialPackage()</code> to the list returned by the <code>getPackages()</code> method</li>
</ul>
</li>
<li>Append the following lines to <code>android/settings.gradle</code>: ``&lsquo; include &rsquo;:react-native-bluetooth-serial' project(':react-native-bluetooth-serial').projectDir = new File(rootProject.projectDir, '../node_modules/react-native-bluetooth-serial/android') ``<code></code></li>
<li><code>Insert the following lines inside the dependencies block in</code>android/app/build.gradle<code>: </code>`&lsquo; compile project(&rsquo;:react-native-bluetooth-serial') ```</li>
</ol>
<h1><a class="anchor" id="autotoc_md6"></a>
Example</h1>
<p>As bluetooth is not available in any simulators, if you want to test it with some bluetooth peripherals you have to run the example on actual device.</p><ol type="1">
<li><code>git clone <a href="https://github.com/rusel1989/react-native-bluetooth-serial.git">https://github.com/rusel1989/react-native-bluetooth-serial.git</a></code></li>
<li><code>cd react-native-bluetooth-serial/BluetoothSerialExample</code></li>
<li><code>npm i</code></li>
<li><code>react-native run-ios/run-android</code></li>
</ol>
<h1><a class="anchor" id="autotoc_md7"></a>
Reading and writing</h1>
<p>In Android after you connect to peripheral <code>write</code> and <code>read</code> methods should work for most of devices out of the box. On ios with BLE it is little bit complicated, you need to know correct serice and characteristics UUIDs. Currently supported and preconfigured services are Red Bear lab, Adafruit BLE, Bluegiga, Laird Virtual Serial Port and Rongta. If you know about some services that you think should be supported send PR.</p>
<p>In near future i will try to improve device discovery on ios and also make services configurable from js.</p>
<h2><a class="anchor" id="autotoc_md8"></a>
API</h2>
<p>All following methods have been tested on both android and ios devices and return promise.</p>
<h3><a class="anchor" id="autotoc_md9"></a>
[android] enable()</h3>
<p>Enable bluetooth currently in android only.</p>
<h3><a class="anchor" id="autotoc_md10"></a>
[android] disable()</h3>
<p>Disable bluetooth currently in android only.</p>
<h3><a class="anchor" id="autotoc_md11"></a>
isEnabled()</h3>
<p>Resolves to boolean value indicating current bluetooth state.</p>
<h3><a class="anchor" id="autotoc_md12"></a>
list()</h3>
<p>Resolves to array of available devices, devices are in following format: </p><div class="fragment"><div class="line">{</div>
<div class="line">    id: String // MAC address (android) or UUID (ios)</div>
<div class="line">    name: Sring // Device name</div>
<div class="line">}</div>
</div><!-- fragment --><p>doesn't return unpaired devices in android.</p>
<h3><a class="anchor" id="autotoc_md13"></a>
[android] discoverUnpairedDevices()</h3>
<p>Resolves to array of unpaired devices on android, device will pair after successful connection. Format is same as list method.</p>
<h3><a class="anchor" id="autotoc_md14"></a>
connect(String id)</h3>
<p>Connect to device by MAC address on android or UUID on ios. Resolves to object with message or rejects with reason of failure.</p>
<h3><a class="anchor" id="autotoc_md15"></a>
disconnect()</h3>
<p>Disconnects from current device should always resolve to true.</p>
<h3><a class="anchor" id="autotoc_md16"></a>
isConnected()</h3>
<p>Resolves to true if there is active connection to device or false if not.</p>
<h3><a class="anchor" id="autotoc_md17"></a>
write(Buffer|String data)</h3>
<p>Write data to connected device, for now buffer is internally converted to Base64 encoded string and decoded to byte array on native side, beacause react native is currently not capable of passing buffer directly to native methods. Resolves to true when write was successful, otherwise rejects with error.</p>
<h2><a class="anchor" id="autotoc_md18"></a>
Events</h2>
<p>You can listen to few event with <code>BluetoothSerial.on(eventName, callback)</code></p>
<p>Currently provided events are:</p><ul>
<li><code>bluetoothEnabled</code> - when user enabled bt</li>
<li><code>bluetoothDisabled</code> - when user disabled bt</li>
<li><code>connectionSuccess</code> - when app connected to device</li>
<li><code>connectionLost</code> - when app lost connection to device (fired with <code>bluetoothDisabled</code>)</li>
</ul>
<p>You can use <code>BluetoothSerial.removeListener(eventName, callback)</code> to stop listening to an event</p>
<h2><a class="anchor" id="autotoc_md19"></a>
TODO</h2>
<ul>
<li>Make services configurable on ios </li>
</ul>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
